<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.metadataTypes"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.name) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.nameLabel | translate}}</mat-label>
      <input (blur)="checkAvailableMultiple(formDefinition.name, formDefinition.version)"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyFocusFirstElement]="true"
             [solidifyValidation]="errors"
             autofocus
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.description) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.description | translate}}</mat-label>
      <textarea [formControl]="fd"
                [required]="formValidationHelper.hasRequiredField(fd)"
                [solidifyValidation]="errors"
                matInput
                rows="4"
      ></textarea>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <solidify-url-input-navigator *ngIf="getFormControl(formDefinition.url) as fd"
                                  [formControl]="fd"
    >
    </solidify-url-input-navigator>

    <ng-container *ngIf="getFormControl(formDefinition.metadataSchema) as fd">
      <mat-form-field *ngIf="!readonly"
                      [appearance]="appearanceInputMaterial"
                      [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                      solidifyTooltipOnEllipsis
      >
        <mat-label>{{'admin.metadataType.form.metadataSchema' | translate}}</mat-label>
        <textarea [formControl]="fd"
                  [highlightAuto]="getFormControl(formDefinition.metadataSchema).value ? getFormControl(formDefinition.metadataSchema).value : ''"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
                  matInput
                  rows="18"
        ></textarea>
        <mat-error #errors
                   solidifyTooltipOnEllipsis
        ></mat-error>
      </mat-form-field>

      <ng-container *ngIf="readonly">
        <div class="test-file-button-wrapper">
          <h2 class="title">{{'admin.metadataType.form.metadataSchemaPreview' | translate}}</h2>
          <button (click)="fileInput.click()"
                  class="load-file"
                  color="primary"
                  mat-button
                  type="button"
                  solidifyFileDropZone
                  (fileDropped)="onFileUpload($event)"
          >
            <solidify-icon [iconName]="iconNameEnum.check"></solidify-icon>
            {{'admin.metadataType.action.testFile' | translate}}
            <input #fileInput
                   (change)="onTestFileUploadByInput($any($event))"
                   [name]="files"
                   class="hide"
                   type="file"
            >
          </button>
        </div>
        <code *ngIf="fd.value | isNonEmptyString"
              [highlightAuto]="fd.value"
              class="code"
        ></code>
      </ng-container>
    </ng-container>

  </ng-template>

  <ng-template #rightTemplate>

    <mat-form-field *ngIf="getFormControl(formDefinition.metadataFormat) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.format | translate}}</mat-label>
      <mat-select [formControl]="fd"
                  [required]="formValidationHelper.hasRequiredField(fd)"
                  [solidifyValidation]="errors"
      >
        <mat-option *ngFor="let format of metadataFormatEnum"
                    [value]="format.key"
                    solidifyTooltipOnEllipsis
        >
          {{format.value | translate}}
        </mat-option>
      </mat-select>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.version) as fd"
                    [appearance]="appearanceInputMaterial"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.version | translate}}</mat-label>
      <input (blur)="checkAvailableMultiple(formDefinition.name, formDefinition.version)"
             [formControl]="fd"
             [required]="formValidationHelper.hasRequiredField(fd)"
             [solidifyValidation]="errors"
             matInput
      >
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <button (click)="fileInput.click()"
            *ngIf="!readonly"
            [matTooltip]="'admin.metadataType.form.buttonUploadSchema.tooltip' | translate"
            class="load-file"
            color="primary"
            mat-button
            type="button"
            solidifyFileDropZone
            (fileDropped)="onFileUpload($event)"
    >
      <solidify-icon [iconName]="iconNameEnum.uploadFile"></solidify-icon>
      {{'admin.metadataType.form.buttonUploadSchema.label' | translate}}
      <input #fileInput
             (change)="onFileUploadByInput($any($event))"
             [name]="files"
             class="hide"
             type="file"
      >
    </button>

  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
